//#include <math.h>
/*http://en.wikipedia.org/wiki/Garbage_collection_%28computer_science%29*/
/*http://en.wikipedia.org/wiki/Free_list*/

#define NULE 0
#define MULE 8888

typedef struct NOIDEA_memory
{
	int id;
	int size;
	struct NOIDEA_memory * last;
	struct NOIDEA_memory * next;
} NOIDEA_memory;

typedef struct NOIDEA_yromem
{
	NOIDEA_memory * space;
	int id;
} NOIDEA_yromem;

/*after reading in wikipedia , i found similarity with Garbage Collection by John McCarthy*/
/*so i've invented nothing*/

/*give an array or a malloc to this function */
NOIDEA_memory * NOIDEA_seg (void * noidea_array, int noidea_size)
{

	NOIDEA_memory * noidea_header = (NOIDEA_memory*)noidea_array;
	NOIDEA_memory * noidea_new = (NOIDEA_memory*)(noidea_array + sizeof(NOIDEA_memory));
	NOIDEA_yromem * noidea_ender = (NOIDEA_yromem*)(noidea_array + noidea_size - sizeof(NOIDEA_yromem));
	noidea_header->id = MULE;
	noidea_header->size = noidea_size;
	noidea_header->last = noidea_new;
	noidea_header->next = noidea_new;
	noidea_new->id = MULE;
	noidea_new->size = noidea_size - sizeof(NOIDEA_memory);
	noidea_new->last = noidea_header;
	noidea_new->next = noidea_header;
	noidea_ender->space = noidea_header;
	noidea_ender->id = MULE;
	return noidea_header;
}

void * NOIDEA_alloc (NOIDEA_memory * noidea_segment, int noidea_size)
{
	if (noidea_size < sizeof(NOIDEA_memory)+sizeof(NOIDEA_yromem))
	{
		noidea_size = sizeof(NOIDEA_memory)+sizeof(NOIDEA_yromem);
	}
	NOIDEA_memory * noidea_pivot = noidea_segment->next;
	NOIDEA_memory * noidea_enogh;
	while (noidea_pivot != noidea_segment)
	{
		if (noidea_pivot->size - sizeof(NOIDEA_memory) > noidea_size + sizeof(int))
		{
			noidea_enogh = noidea_pivot;
			noidea_pivot = noidea_segment->last;
		}
		noidea_pivot = noidea_pivot->next;
	}

	if (noidea_enogh != 0)
	{
		NOIDEA_memory * noidea_mov = (NOIDEA_memory*)((void*)noidea_enogh + noidea_size + sizeof(int));
		NOIDEA_yromem * noidea_set = (NOIDEA_yromem*)((void*)noidea_enogh + noidea_enogh->size - sizeof(NOIDEA_yromem));
		void * noidea_new = (void*) noidea_enogh;

		noidea_mov->id = noidea_enogh->id;
		noidea_mov->size = noidea_enogh->size - noidea_size - sizeof(int);
		noidea_mov->last = noidea_enogh->last;
		noidea_mov->next = noidea_enogh->next;
		noidea_mov->last->next = noidea_mov;
		noidea_mov->next->last = noidea_mov;

		noidea_set->space = noidea_mov;
		*(int*)noidea_new = noidea_size;
		noidea_new = noidea_new +sizeof(int);

		//debug debug debug debug debug debug
		*(int*)noidea_new = 0;
		*(int*)(noidea_new + sizeof(int)) = 0;
		*(int*)(noidea_new + (sizeof(int) * 2)) = 0;
		//debug debug debug debug debug debug

		return noidea_new;
	}
	return NULE;
}

void NOIDEA_free (NOIDEA_memory * noidea_segment, void * noidea_offset)
{
	int noidea_size = *(int*)(noidea_offset - sizeof(int));
	NOIDEA_memory * noidea_new = (NOIDEA_memory*) (noidea_offset - sizeof(int));
	NOIDEA_yromem * noidea_end = (NOIDEA_yromem*) (noidea_offset + noidea_size - sizeof(NOIDEA_yromem));
	noidea_new->id = MULE;
	noidea_new->size = noidea_size + sizeof(int);
	noidea_new->last = noidea_segment;
	noidea_new->next = noidea_segment->next;
	noidea_new->last->next = noidea_new;
	noidea_new->next->last = noidea_new;
	noidea_end->id = MULE;
	noidea_end->space = noidea_new;
	if ((*(int*)(noidea_offset + noidea_size)) == MULE )
	{

		NOIDEA_memory * noidea_forward = (NOIDEA_memory*)(noidea_offset + noidea_size);
		NOIDEA_yromem * noidea_foreend = (NOIDEA_yromem*)((void*)noidea_forward + noidea_forward->size - sizeof(NOIDEA_yromem));
		noidea_new->size = noidea_new->size + noidea_forward->size;
		noidea_forward->next->last = noidea_forward->last;
		noidea_forward->last->next = noidea_forward->next;
		noidea_foreend->space = noidea_new;
		//debug
		noidea_end->id = 0;
		noidea_end->space = 0;
		noidea_forward->id = 0;
		noidea_forward->size = 0;
		noidea_forward->last = 0;
		noidea_forward->next = 0;
		//debug
		noidea_end = noidea_foreend;
	}
	if ((*(int*)(noidea_offset - (sizeof(int)*2))) == MULE )
	{
		NOIDEA_yromem * noidea_backend = (NOIDEA_yromem*)(noidea_offset - (sizeof(int)*2) - sizeof(void*));
		NOIDEA_memory * noidea_bacward = noidea_backend->space;

		noidea_bacward->size = noidea_bacward->size + noidea_new->size;
		noidea_new->next->last = noidea_new->last;
		noidea_new->last->next = noidea_new->next;
		noidea_end->space = noidea_bacward;
		//debug
		noidea_backend->id = 0;
		noidea_backend->space = 0;
		noidea_new->id = 0;
		noidea_new->size = 0;
		noidea_new->last = 0;
		noidea_new->next = 0;
		//debug
		noidea_new = noidea_bacward;
	}
}

//================================================================================
//================================================================================
//================================================================================

/*http://en.wikipedia.org/wiki/Linked_list*/


typedef struct NOIDEA_node
{
	void * pack;
	struct NOIDEA_node * last;
	struct NOIDEA_node * next;
} NOIDEA_node;

NOIDEA_node * NOIDEA_create (NOIDEA_node * noidea_src, void * noidea_pack, void * noidea_ptr)
{
	if (noidea_ptr == 0)
	{	return 0;	}

	NOIDEA_node * noidea_nud = (NOIDEA_node*) noidea_ptr;
	noidea_nud->pack = noidea_pack;

	if (noidea_src != 0)
	{
		noidea_nud->last = noidea_src;
		noidea_nud->next = noidea_src->next;
		noidea_nud->last->next = noidea_nud;
		noidea_nud->next->last = noidea_nud;
	}
	else
	{
		noidea_nud->last = noidea_nud;
		noidea_nud->next = noidea_nud;
	}

	return noidea_nud;
}

void * NOIDEA_destroy (NOIDEA_node * noidea_src, NOIDEA_node * noidea_nud)
{
	if ((noidea_src == 0)||(noidea_nud == 0))
	{	return;		}

	if (noidea_src == noidea_nud)
	{
		//you shouldnt destroy sentinel if array is not empty
			if (noidea_src != noidea_src->next)
			{
				return;
			}
	}

	noidea_nud->last->next = noidea_nud->next;
	noidea_nud->next->last = noidea_nud->last;

	noidea_nud->pack = 0;
	noidea_nud->last = 0;
	noidea_nud->next = 0;

	return (void*) noidea_nud;	//return ptr in case of alloc/free
}

void * NOIDEA_loop (NOIDEA_node * noidea_src)
/* all node will move around noidea_src */
/* so its sure that youll get them all */
{
	NOIDEA_node * noidea_nud = noidea_src->next;

	noidea_src->last->next = noidea_src->next;
	noidea_src->next->last = noidea_src->last;

	noidea_nud->next->last = noidea_src;
	noidea_src->next = noidea_nud->next;

	noidea_nud->next = noidea_src;
	noidea_src->last = noidea_nud;


	return noidea_nud->pack;
}


//================================================================================
//================================================================================
//================================================================================



typedef struct NOIDEA_agenda
{
	signed long int wait;		//interval between call
	void (*func)(void);		//function to call
	signed long int till;		//wait till to execute
	signed long int idle;		//time left before execute
	signed long int loop;		//value that end loop
	NOIDEA_node * node;		//the node that list it
} NOIDEA_agenda;


NOIDEA_node * NOIDEA_schedule (NOIDEA_node * noidea_sentinel, void (*noidea_func)(void), signed long int noidea_wait ,void * noidea_ptr)
{
	NOIDEA_agenda * noidea_now = (NOIDEA_agenda*) noidea_ptr;
	NOIDEA_node * noidea_node_now = NOIDEA_create(noidea_sentinel,noidea_now,noidea_ptr + sizeof(NOIDEA_agenda));
	noidea_now->node = noidea_node_now;
	noidea_now->func = noidea_func;
	noidea_now->wait = noidea_wait;

	return noidea_node_now;
}

void * NOIDEA_cancel (NOIDEA_node * noidea_node_today, NOIDEA_node * noidea_node_now)
{
	NOIDEA_agenda * noidea_now = noidea_node_now->pack;
	noidea_now->wait = 0;
	noidea_now->func = 0;
	noidea_now->idle = 0;
	noidea_now->till = 0;
	noidea_now->loop = 0;
	noidea_now->node = 0;
	noidea_node_now = NOIDEA_destroy (noidea_node_today, noidea_node_now);
	return ((void*)noidea_now);
}

signed long int NOIDEA_do (NOIDEA_node * noidea_sentinel, signed long int noidea_time)
{
		NOIDEA_agenda * noidea_today = (NOIDEA_agenda*)noidea_sentinel->pack;
		NOIDEA_agenda * noidea_now;
		noidea_today->loop += 1;
		noidea_today->idle = noidea_today->wait;
		int noidea_yet = 0;
		while (noidea_yet != 1)
		{

			noidea_now = NOIDEA_loop(noidea_sentinel);
			if (noidea_now->loop == noidea_today->loop)
			{
				noidea_yet = 1;
			}
			

			if (noidea_now->till == 0)
			{
				noidea_now->till = noidea_time + noidea_now->wait;
			}
			if (noidea_now->till <= noidea_time)
			{
				noidea_now->till = noidea_time + noidea_now->wait;
				noidea_now->idle = 0;
				noidea_now->func();
				noidea_yet = 1;
			}
			else
			{
				noidea_now->idle = noidea_now->till - noidea_time;
				noidea_now->loop = noidea_today->loop;
			}
			if (noidea_now->idle < noidea_today->idle)
			{
				noidea_today->idle = noidea_now->idle;
			}
		}
	return noidea_today->idle;
}

//================================================================================
//================================================================================
//================================================================================
//==============================the object========================================
//================================================================================
//================================================================================
//================================================================================

typedef struct noidea_env
{
	void * self;

	NOIDEA_memory * env;
	void * (*alloc)(struct noidea_env*,int);
	void (*free) (struct noidea_env * , void * );

	NOIDEA_node * list;
	NOIDEA_node * (*append) (struct noidea_env * ,int);
	void (*remove) (struct noidea_env * ,NOIDEA_node*);
	void * (*next) (struct noidea_env * );

	NOIDEA_node * thread;
	NOIDEA_node * (*start) (struct noidea_env * ,void (*)(void),signed long int);
	void (*stop) (struct noidea_env * , NOIDEA_node *);
	signed long int (*loop) (struct noidea_env *, signed long int );

}noidea_env;
void * noidea_alloc(noidea_env* noidea_self,int size){	return NOIDEA_alloc(noidea_self->env,size);}
void noidea_free(noidea_env* noidea_self, void * ptr){	NOIDEA_free(noidea_self->env,ptr);}

typedef NOIDEA_node noidea_nod;
NOIDEA_node * noidea_append(struct noidea_env * noidea_self ,int noidea_size)
{	void * noidea_mem = noidea_alloc(noidea_self,sizeof(NOIDEA_node)+noidea_size);
	return NOIDEA_create(noidea_self->list,noidea_mem + sizeof(NOIDEA_node),noidea_mem);
}
void noidea_remove(struct noidea_env * noidea_self, NOIDEA_node * noidea_nud){	noidea_free(noidea_self,NOIDEA_destroy(noidea_self->list,noidea_nud));}
void * noidea_next(struct noidea_env * noidea_self){	NOIDEA_loop(noidea_self->list);}

void noidea_rien(void){}
NOIDEA_node * noidea_start (struct noidea_env * noidea_self,void (*noidea_func)(void),signed long int noidea_when){	return NOIDEA_schedule(noidea_self->thread,noidea_func,noidea_when,noidea_alloc(noidea_self,sizeof(NOIDEA_node)+sizeof(NOIDEA_agenda)));}
void noidea_stop (struct noidea_env * noidea_self, NOIDEA_node * noidea_thread){	NOIDEA_free(noidea_self->env,NOIDEA_cancel(noidea_self->thread,noidea_thread));}
signed long int noidea_loop (struct noidea_env * noidea_self, signed long int noidea_now){	return NOIDEA_do(noidea_self->thread,noidea_now);}

noidea_env * noidea_init(void * ptr, int size)
{
	noidea_env * self = (noidea_env*) ptr;
	self->self = self;

	self->env = NOIDEA_seg(ptr + sizeof(noidea_env),size - sizeof(noidea_env));
	self->alloc = noidea_alloc;
	self->free =  noidea_free;

	self->list = NOIDEA_create(0,ptr,noidea_alloc(self,sizeof(NOIDEA_node)));
	self->append = noidea_append;
	self->remove = noidea_remove;
	self->next = noidea_next;

	self->thread = NOIDEA_schedule(0,&noidea_rien,1000000,noidea_alloc(self,sizeof(NOIDEA_node)+sizeof(NOIDEA_agenda)));
	self->start = noidea_start;
	self->stop = noidea_stop;
	self->loop = noidea_loop;

	return self;
}
//================================================================================
//================================================================================
//================================================================================
//==============================the object========================================
//================================================================================
//================================================================================
//================================================================================

NOIDEA_node * noidea_int2dec (noidea_env * noidea_self, int noidea_int)
{
	//determine size of the str
	int noidea_size = 1;		//start with control character "d"
	int noidea_tmp = noidea_int;
	while (noidea_tmp != 0)
	{
		noidea_size += 1;
		noidea_tmp /= 10;
	}
	noidea_size += 1;		//while it end with termination character "#"	

	NOIDEA_node * noidea_nud = noidea_append(noidea_self,noidea_size);
	char * noidea_str = noidea_nud->pack;

	*(noidea_str + noidea_size) = (char)35;	//termination character "#"
	noidea_tmp = noidea_int;
	while (noidea_size != 2)
	{
		noidea_size -= 1;
		*(noidea_str + noidea_size) = (char) (48 +(noidea_tmp % 10));
		noidea_tmp = noidea_tmp / 10;

	}
	*(noidea_str) = (char) 100;	// control character "d" mean decimal

	return noidea_nud;
}

int noidea_dec2int(NOIDEA_node * noidea_nud)
{
	int pivot = 1;
	int noidea_int = 0;
	char * noidea_str = (noidea_nud->pack);
	if ((char)100 == *noidea_str)
	{

		char noidea_num = (char)100;
		while ((noidea_num != 35)&&(noidea_num !=46))		//end at "@" or "."
		{
			noidea_num = *(noidea_str + pivot);
			if ((noidea_num >= (char)48)&&(noidea_num <= (char)58))
			{
				int num = (int)(noidea_num - 48);
				noidea_int = noidea_int * 10;
				noidea_int = noidea_int + num;
			}
			pivot += 1;
		}
	}
	return noidea_int;
}

int noidea_decexp(float noidea_float)
{
	float noidea_tmp = noidea_float;
	float noidea_exp = 0;
	while (noidea_tmp != 0)
	{
		noidea_tmp -= (int) noidea_tmp;
		noidea_tmp *= 10;
		noidea_exp += 1.0;
	}
	return (int)noidea_exp;	
}

int noidea_decpow(int noidea_exp)
{
	int noidea_tmp = noidea_exp;
	float noidea_pow = 10;
	while (noidea_tmp != 0)
	{
		noidea_pow *= 10;
		noidea_tmp -= 1;
	}
	return (int) noidea_pow;
}

NOIDEA_node * noidea_float2dec(noidea_env * noidea_self, float noidea_float)
{
	int noidea_exp = noidea_decexp(noidea_float);
	int noidea_pow = noidea_decpow(noidea_exp);
	int noidea_int = (int)(noidea_float * (noidea_pow));

	return 0;

}

float noidea_dec2float(NOIDEA_node * noidea_nud)
{
	int flag = 1;
	int pivot = 1;
	int noidea_int = 0;
	float noidea_float = 0;
	int fpivot = 1;
	char * noidea_str = (noidea_nud->pack);
	if ((char)102 == *noidea_str)
	{

		char noidea_num = (char)100;
		while (noidea_num != 35)		//end at "#" 
		{
			noidea_num = *(noidea_str + pivot);
			if ((noidea_num >= (char)48)&&(noidea_num <= (char)58))
			{
				if (flag == 1)
				{
					int num = (int)(noidea_num - 48);
					noidea_int = noidea_int * 10;
					noidea_int = noidea_int + num;
				}
				else
				{
					float fnum = (float)(noidea_num - 48);
					noidea_float = noidea_float + fnum;
					noidea_float = noidea_float * 10;
					fpivot += 1;
				}
			}
			if (noidea_num == (char)46)
			{
				flag = 0;
			}
			pivot += 1;
		}
	}
	noidea_float = noidea_float / noidea_decpow(fpivot);
	return (float)noidea_int + noidea_float;
}
//-----------------------------------------------------------------------------------------------------------------
NOIDEA_node * noidea_int2bin (noidea_env * noidea_self, int noidea_int)
{
	//determine size of the str
	int noidea_size = 1;		//start with control character "b"
	int noidea_tmp = noidea_int;
	while (noidea_tmp != 0)
	{
		noidea_size += 1;
		noidea_tmp /= 2;
	}
	noidea_size += 1;		//while it end with termination character "#"	

	void * noidea_ptr = noidea_alloc(noidea_self,noidea_size + sizeof(NOIDEA_node));
	char * noidea_str = noidea_ptr +  sizeof(NOIDEA_node);

	*(noidea_str + noidea_size) = (char)35;	//termination character "#"
	noidea_tmp = noidea_int;
	while (noidea_size != 0)
	{
		noidea_size -= 1;
		*(noidea_str + noidea_size) = (char) (48 +(noidea_tmp % 2));
		noidea_tmp = noidea_tmp / 2;

	}
	*(noidea_str) = (char) 98;	// control character "b" mean binary

	NOIDEA_node * noidea_nud = NOIDEA_create(0,noidea_str,noidea_ptr);

	return noidea_nud;
}

int noidea_bin2int(NOIDEA_node * noidea_nud)
{
	int pivot = 1;
	int noidea_int = 0;
	char * noidea_str = (noidea_nud->pack);
	if ((char)98 == *noidea_str)
	{

		char noidea_num = (char)98;
		while (noidea_num != 35)
		{
			noidea_num = *(noidea_str + pivot);
			if ((noidea_num >= (char)48)&&(noidea_num <= (char)49))
			{
				int num = (int)(noidea_num - 48);
				noidea_int = noidea_int * 2;
				noidea_int = noidea_int + num;
			}
			pivot += 1;
		}
	}
	return noidea_int;
}
//----------------------------------------------------------------------------------------------------------------------
NOIDEA_node * noidea_int2hex(noidea_env * noidea_self, int noidea_int)
{

	return 0;
}

int noidea_hex2int (NOIDEA_node * noidea_nud)
{

	return 0;
}
//-----------------------------------------------------------------------------------------------------------------------
